package operaciones;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.InputMismatchException;

import java.util.Iterator;
import java.util.List;
import java.util.Set; 
import java.util.Scanner;


import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.exception.ConstraintViolationException;

import datos.*;


public class OperacionesArticulos {
	static	SessionFactory sesion = Conexion.getSession();			
	static Session session = sesion.openSession();	
	static Scanner teclado = new Scanner(System.in);
 
public static void main(String[] args)    
 {
    int op = 0;
    do 
	  { 
		dibujamenu();
        System.out.print( "\tElige operación.\t");
        op = teclado.nextInt(); 
       switch(op){
	    	case 1: insertar(); break;
		    case 2: modificar();  break;
		    case 3: borrar(); break;
		    case 4: Visualizararticulo(); break;
		    case 5: Visualizardetallearticulo(); break;
    }  
  }while(op!=0);

  session.close();
  sesion.close();
	
}//fin main
////////////////////////////////////////////////////////////////////////////////////
private static void Visualizararticulo () {

System.out.println("------------------------------------------------------------------------------------------------------------------");
System.out.println("COD ARTI     DENOMINACION             PRECIO      STOCK     ZONA     COD PROV     NOMBRE PROV         LOCALIDAD   ");
System.out.println("-------- -------------------------- ------------ ------- ----------- -------- -------------------- ---------------");	   
String patron="%-8d %-26s %7.2f \t%7d %11s \t%5d %-20s %-15s";
String cadena ="";

Articulos arti = new Articulos(); 			
Query q = session.createQuery("from Articulos");
List <Articulos> lista = q.list();
for(int i=0;i<lista.size();i++)
{
	arti = lista.get(i); 
	cadena = String.format(patron, arti.getCodarticulo(),  arti.getDenominacion(), arti.getPrecio(),
	arti.getStock(), arti.getZona(), arti.getProveedores().getCodigoProv(), 
	arti.getProveedores().getNombre(), arti.getProveedores().getLocalidad());
	System.out.println(cadena);	   
}
System.out.println("-------- -------------------------- ------------ ------- ----------- -------- -------------------- ---------------");	   

volveralmenu();	

}//Visualizar

////////////////////////////////////////////////////////////////////////////////////
private static void Visualizardetallearticulo() {

System.out.println("------------------------------------------------------------------------------------------------------------------");
System.out.println("COD ARTI     DENOMINACION             PRECIO      STOCK     ZONA     COD PROV     NOMBRE PROV         LOCALIDAD   ");
System.out.println("-------- -------------------------- ------------ ------- ----------- -------- -------------------- ---------------");	   
String patron="%-8d %-26s %7.2f \t%7d %11s \t%5d %-20s %-15s";
String cadena ="";
String patron2="%-6d %-8d %7.2f %12s %-25s";

Articulos arti = new Articulos(); 			
Query q = session.createQuery("from Articulos a order by a.codarticulo");
List <Articulos> lista = q.list();
for(int i=0;i<lista.size();i++)
{
	arti = lista.get(i); 
    cadena = String.format(patron, arti.getCodarticulo(),  arti.getDenominacion(), arti.getPrecio(),
    		arti.getStock(), arti.getZona(), arti.getProveedores().getCodigoProv(), 
    		arti.getProveedores().getNombre(), arti.getProveedores().getLocalidad());
    System.out.println(cadena);	   
    // cargamos las compras de ese artículo
    Set<Detallecompras> listacompras = arti.getDetallecomprases();
	//obtenemos las compras
	Iterator <Detallecompras> it = listacompras.iterator();
	System.out.println("Número de compras del artículo: "+listacompras.size() );	
	if (listacompras.size()!=0)
	{   System.out.println("\t\t------ -------- -------- ------------- ----------------------");
		System.out.println("\t\tNumCom Unidades  Importe  Fecha comp   Nombre Cliente ");
		System.out.println("\t\t------ -------- -------- ----------- ----------------------");
		Detallecompras det = new Detallecompras();
		while(it.hasNext()) {
			det=it.next();
			cadena = String.format(patron2,det.getId().getNumcompra(), det.getUnidades(),
			det.getUnidades() * arti.getPrecio(), det.getCompras().getFechacompra(),
			det.getCompras().getClientes().getNombre());
			  System.out.println("\t\t" + cadena);	   
		 } // fin while detallecomprases
	}// fin if listacompras.size() 	    
	System.out.println("-------- -------------------------- ------------ ------- ----------- -------- -------------------- ---------------");	   
} // fin while articulos

volveralmenu();	

}//Visualizardetalle


////////////////////////////////////////////////////////////////////////////////////
private static void modificar() {

short codarticulo;	 
short stock ;
Articulos artic;
System.out.println("----------------------------------------------");
System.out.println("<<<< ACTUALIZAR EL STOCK DE UN ARTÍCULO  >>>>>");
System.out.println("----------------------------------------------");

do{
try {
		System.out.print("Teclea el número de artículo: "); 
		codarticulo=teclado.nextShort(); 
		teclado.nextLine();
		artic = (Articulos) session.get(Articulos.class, codarticulo);	
		if (artic==null) 			
		   System.out.println(">>>El CODIGO DE ARTÍCULO NOOO EXISTE: "+ 
		                     codarticulo + ", teclea de nuevo."); 	
		else break; 
	} catch (InputMismatchException e) {
	    System.out.println(">>>El CODIGO DE artículo DEBE SER UN NUMÉRICO SHORT. "); 
	    teclado.nextLine();
	} 	
}while (true);
// Visualizamos el articulo a actualizar
System.out.println("--------------------------------------------------------------------");
System.out.println("DENOMINACION: " + artic.getDenominacion() + ", PRECIO: " +
		artic.getPrecio() +", STOCK:" + artic.getStock());
// Leemos el nuevo stock
do{
	System.out.print("Teclea las unidades a sumar al STOCK del artículo: "); 
	try {
		stock=teclado.nextShort(); 
		teclado.nextLine();
		break;
	} catch (InputMismatchException e) {
	System.out.println(">>>EL STOCK DEBE SER NUMÉRICO"); 
	teclado.nextLine();
	} 		
}while (true);

Transaction tx =session.beginTransaction();
short stockant = artic.getStock();
artic.setStock((short) (stockant + stock));
session.save(artic);
tx.commit();
System.out.println("<<<<ARTÍCULO ACTUALIZADO.>>>>>");
System.out.println("--------------------------------------------------------------------");
volveralmenu();	
} // modificar
////////////////////////////////////////////////////////////////////////////////////


private static void insertar() {
	 	
short codarticulo; String denominacion;	 
float precio; short stock ;
String zona ; short codigo_prov;
Articulos artic; Proveedores prove;
System.out.println("<<<<Teclea los datos del artículo a insertar>>>>>");
System.out.println("-------------------------------------------------");
do{
 try {
	  System.out.print("Teclea el número de artículo: "); 
	   codarticulo=teclado.nextShort(); 
	   teclado.nextLine();
		artic = (Articulos) session.get(Articulos.class, codarticulo);	
		if (!(artic==null) )			
		   System.out.println(">>>El CODIGO DE ARTÍCULO YAAA EXISTE: "+ 
		                     codarticulo + ", teclea de nuevo."); 	
		else break; 
	 } catch (InputMismatchException e) {
        System.out.println(">>>El CODIGO DE artículo DEBE SER NUMÉRICO SHORT. "); 
        teclado.nextLine();
     } 	
  }while (true);
  // Leemos nombre      		       
  System.out.print("Teclea la denominación del artículo: "); 
  denominacion=teclado.nextLine(); 
   // leemos el precio
  do{
	   System.out.print("Teclea el precio de artículo: "); 
	   try {
		   precio=teclado.nextFloat(); 
		   teclado.nextLine();
		   break;
		 } catch (InputMismatchException e) {
	         System.out.println(">>>El PRECIO DEL artículo DEBE SER NUMÉRICO FLOAT. "); 	
	         teclado.nextLine();
	      } 		 
   }while (true);
   // Leemos el stock
   do{
	   System.out.print("Teclea el stock del artículo: "); 
	   try {
		   stock=teclado.nextShort(); 
		   teclado.nextLine();
		   break;
		 } catch (InputMismatchException e) {
	         System.out.println(">>>EL STOCK DEBE SER NUMÉRICO SHORT."); 
	         teclado.nextLine();
	      } 		
    }while (true);
   // Leemos zona      		       
   System.out.print("Teclea el nombre de la zona: "); 
   zona=teclado.nextLine(); 
   do{
     try {  // se lee el proveedor
		  System.out.print("Teclea el número de proveedor: "); 
		  codigo_prov=teclado.nextShort(); 
		  teclado.nextLine();
		  prove = (Proveedores) session.get(Proveedores.class, codigo_prov);	
		  if (prove==null) 			
			   System.out.println(">>>El CODIGO DE PROVEEDOR NOOO EXISTE: "+ 
					   codigo_prov + ", teclea de nuevo."); 	
			else break; 
	 	 } catch (InputMismatchException e) {
	        System.out.println(">>>El CODIGO DE PROVEEDOR DEBE SER NUMÉRICO SHORT. "); 
	        teclado.nextLine();
	     } 	
	  }while (true);

   try
	{Transaction tx =session.beginTransaction();
	Articulos artinue = new Articulos();
	artinue.setCodarticulo(codarticulo);
	artinue.setDenominacion(denominacion);
	artinue.setPrecio(precio);
	artinue.setStock(stock);
	artinue.setZona(zona);
	artinue.setProveedores(prove);
	session.save(artinue);
	tx.commit();
	System.out.println("<<<<ARTÍCULO INSERTADO CORRECTAMENTE>>>>>");	
	System.out.println("--------------------------------------------------------------------");
	} catch (ConstraintViolationException e){
		  System.out.println ("-------------------------------------");
	      System.out.println ("Código de error: " + e.getErrorCode());
	      System.out.println ("Mensaje de error: " + e.getMessage());
	      System.out.println ("-------------------------------------");
	}

volveralmenu();			
} // insertar

////////////////////////////////////////////////////////////////////////////////////
private static void borrar() {

short codarticulo;	 
Articulos artic;
System.out.println("----------------------------------------------");
System.out.println("<<<< BORRAR UN ARTÍCULO  >>>>>");
System.out.println("----------------------------------------------");

do{
try {
		System.out.print("Teclea el número de artículo: "); 
		codarticulo=teclado.nextShort(); 
		teclado.nextLine();
		artic = (Articulos) session.get(Articulos.class, codarticulo);	
		if (artic==null) 			
		   System.out.println(">>>El CODIGO DE ARTÍCULO NOOO EXISTE: "+ 
		                     codarticulo + ", teclea de nuevo."); 	
		else break; 
	} catch (InputMismatchException e) {
	    System.out.println(">>>El CODIGO DE artículo DEBE SER UN NUMÉRICO SHORT. "); 
	    teclado.nextLine();
	} 	
}while (true);
System.out.println("--------------------------------------------------------------------");
System.out.println("DENOMINACION: " + artic.getDenominacion() + ", PRECIO: " +
		artic.getPrecio() +", STOCK:" + artic.getStock());

try
{
	Transaction tx =session.beginTransaction();
	session.delete(artic);
	tx.commit();
	System.out.println("<<<<ARTÍCULO BORRADO.>>>>>");
	System.out.println("--------------------------------------------------------------------");
} catch (ConstraintViolationException e){
	  System.out.println ("-------------------------------------");
      System.out.println ("Código de error: " + e.getErrorCode());
      System.out.println ("Mensaje de error: " + e.getMessage());
      System.out.println ("-------------------------------------");
}
volveralmenu();	
}// borrar

////////////////////////////////////////////////////////////////////////////////////
private static void dibujamenu() {  	
	System.out.println("\t..............................................................");
	System.out.println("\t. INSERT - UPDATE - DELETE de artículos en pruebas de MySQL...");
	System.out.println("\t..............................................................\n"
	+ "\t\t.  1 Insertar un artículo. \n"
	+ "\t\t.  2 Modificar el stock de un artículo.  \n"
	+ "\t\t.  3 Borrar un artículo. \n"
	+ "\t\t.  4 Visualizar la tabla articulos. \n"
	+ "\t\t.  5 Visualizar el detalle de las compras de los artículo. \n"
	+ "\t\t.  0 SALIR.\n"
	+ "\t.................................................................\n");
} // fin dibujamenu
////////////////////////////////////////////////////////////////////////////////////
private static void volveralmenu() {
try {
	System.out.println( "Pulsa una tecla para volver. ");
	System.in.read();
	} catch (IOException e) {System.out.println (e);}
}// volveralmenu
////////////////////////////////////////////////////////////////////////////////////
}
