package operaciones;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;

import datos.*;

public class ResumenesEstadisticos {
	
	static SessionFactory sesion = Conexion.getSession();			
	static Session session = sesion.openSession();	
	
	static Scanner teclado = new Scanner(System.in);
 
public static void main(String[] args)    
 	 {
 		int op = 0;
 		do 
 		  { 
 			dibujamenu();
 	        System.out.print( "\tElige operación.\t");
	        op = teclado.nextInt(); 
            switch(op){ 
		    	case 1: resumenarticulos(); break;
			    case 2: resumenclientes();  break;
			    case 3: resumenproveedores();  break;
			    case 4: detallecomprasdeclientes(); break;
			    case 5: break;
        }  
	  }while(op!=0);
 	  session.close();
 	  sesion.close();
	
}//fin main
////////////////////////////////////////////////////////////////////////////////////
private static void resumenproveedores() {
	
System.out.println("-----------------------------------------------------");
System.out.println("              RESUMEN DE PROVEEDORES ");	  
System.out.println("--------------------------------------------------------");	
System.out.println("COD PROV  NOMBRE                LOCALIDAD       NUM_ART ");
System.out.println("-------- --------------------- ---------------- --------");	   
String patron="%-8d %-20s  %-20s %d ";
String cadena ="";			
Query q = session.createQuery("select p.codigoProv, p.nombre, p.localidad , "
		+ " count(a.codarticulo)  from Proveedores p join p.articuloses a "
		+ " group by  p.codigoProv, p.nombre, p.localidad ");
long maximo=0;
List<Object[]> listaprove = q.list(); 

if (listaprove.size()>0)
{   long sumaartic = 0;
	for (int i = 0; i < listaprove.size(); i++)
	{
	  Object res[] = listaprove.get(i); 
	  cadena = String.format(patron, res[0], res[1], res[2], res[3]);
	  System.out.println(cadena);
	  sumaartic = sumaartic + (long)res[3];
	  if (maximo < (long)res[3])
		  maximo = (long)res[3];
	}
	System.out.println("-------- --------------------- ---------------- ---------------");	
	System.out.printf("Número de proveedores %d: \n",listaprove.size() );
	System.out.printf("Media de artículos por proveedor: %4.2f \n",(float)sumaartic/(float)listaprove.size() );
	// Proveedor con más artículos
	 q = session.createQuery("select p.codigoProv, p.nombre,  count(a.codarticulo) " + 
	             " from Proveedores p join p.articuloses a "
				+ " group by  p.codigoProv, p.nombre, p.localidad having "
				+ "  count(a.codarticulo) = " + maximo);
	 List<Object[]> provmaxartis = q.list(); 
	 System.out.printf("Proveedores que suministran más artículos (máximo = %d): \n",maximo );
	 for (int i = 0; i < provmaxartis.size(); i++)
		{
		   Object res[] = provmaxartis.get(i); 
		   System.out.printf("\tCod proveedor: %d, Nombre: %s \n", res[0],  res[1]); 
		 }
}
else
	System.out.println(" <<<<<<<<< NO HAY PROVEEDORES >>>>>>> ");	
System.out.println("-------- --------------------- ---------------- ---------------");	 
volveralmenu();		
}//resumenproveedores
////////////////////////////////////////////////////////////////////////////////////
private static void detallecomprasdeclientes () 
{
System.out.println("-------------------------------------------------------------------------");
System.out.println("              DETALLE DE LAS COMPRAS DE LOS CLIENTES ");	  
System.out.println("-------------------------------------------------------------------------");	
Query q = session.createQuery("from Clientes");
List <Clientes> lista = q.list();
if (lista.size()>0)
	{   
	    Clientes cli = new Clientes(); 	
		for (int i=0;i<lista.size();i++)
		{
		    cli=lista.get(i);
			System.out.printf("COD CLI: %d,  NOMBRE: %s, LOCALIDAD: %s \n",
					 cli.getCodigoCli(), cli.getNombre(), cli.getLocalidad());
			Set<Compras> listacompras = cli.getComprases();
			//obtenemos las compras
			Iterator <Compras> itcompras = listacompras.iterator();
			System.out.println("Número de compras del cliente: "+listacompras.size() );	
			if (listacompras.size()!=0)
			{  
				comprasdeuncliente(itcompras);
			} 
			else
				System.out.println(" <<<<<<<<<CLIENTE SIN COMPRA >>>>>>> ");	  
			System.out.println("-------- --------------------- ---------------- -----------");	  
		} // fin while clientes	   
  }
  else
	System.out.println(" <<<<<<<<< NO HAY CLIENTES >>>>>>> ");	  
System.out.println("-------- --------------------- ---------------- -----------");	 
volveralmenu();		
	
} //detallecomprasdeclientes
////////////////////////////////////////////////////////////////////////////////////
private static void comprasdeuncliente(Iterator<Compras> itcompras) {
Compras comp = new Compras();
while(itcompras.hasNext()) {
	System.out.println("   ------ --------------------- ---------------- ------");
	comp = itcompras.next(); 
	System.out.printf("\tNumCom: %d,  Fecha compra: %s \n",comp.getNumcompra(), comp.getFechacompra());
	System.out.println("\t---------------------------------------");
	Set<Detallecompras> listadetalle = comp.getDetallecomprases();
	//obtenemos los detalle de la compra
	Iterator <Detallecompras> itdetalle = listadetalle.iterator();
	System.out.println("\tNúmero de artículos de la compra: "+listadetalle.size() );	
	if (listadetalle.size()!=0)	  
		detalledelascomprasdeunclien(itdetalle);		
	else
		System.out.println(" <<<<<<<<<CLIENTE SIN DETALLE-COMPRA >>>>>>> ");	  
	 } // fin while compras del cliente
}//comprasdeuncliente
////////////////////////////////////////////////////////////////////////////////////
private static void detalledelascomprasdeunclien(
	Iterator<Detallecompras> itdetalle)
{
	System.out.println("\tCOD     UNIDADES     PVP       IMPORTE ");
	System.out.println("\t---------------------------------------");
	String cadena;
	float totaluni=0, totalimpor=0;
	String patron="\t%-5d \t%5d %11.2f %12.2f ";
	Detallecompras det = new Detallecompras();
	while(itdetalle.hasNext()) {
		det=itdetalle.next();
		float importe = det.getUnidades().floatValue() * det.getArticulos().getPrecio().floatValue();
		cadena = String.format(patron,det.getArticulos().getCodarticulo(),
				det.getUnidades(), det.getArticulos().getPrecio(), importe);
		  System.out.println(cadena);	
		// sumar a totales  
		totaluni= totaluni + det.getUnidades().floatValue() ;
		totalimpor = totalimpor +	importe;	  
	 } // fin while listadetallecomprases
	 // Visualizar totales
	 System.out.println("\t---------------------------------------");
	 String patron2="\t%-9s %-5.0f \t%s %12.2f ";
	 cadena = String.format(patron2,"TOTALES:",totaluni," ", totalimpor );
	 System.out.println(cadena);
} //detalledelascomprasdeunclien
////////////////////////////////////////////////////////////////////////////////////
private static void resumenclientes () {
float maximp = 0, maxcom=0;

System.out.println("-------------------------------------------------------------------------");
System.out.println("                     RESUMEN DATOS DE CLIENTES ");	  
System.out.println("-------------------------------------------------------------------------");
System.out.println("COD CLI  NOMBRE                LOCALIDAD        NUM_COMPRAS TOTALIMPORTE");
System.out.println("-------- --------------------- ---------------- ----------- -------------");	   
String patron="%-8d %-20s  %-15s %8d \t%8.2f ";
String cadena ="";	
Clientes cli = new Clientes(); 			
Query q = session.createQuery("from Clientes");
List <Clientes> lista = q.list();
if (lista.size()>0)
{
	for (int i=0;i<lista.size(); i++) 
	{
		cli = (Clientes) lista.get(i); 
		Long numc =  (Long) session.createQuery(
			    "select count(*) from Compras c where c.clientes.codigoCli = "+ cli.getCodigoCli() ).uniqueResult();
		 Query consu =  session.createQuery(
				"select coalesce(sum( det.articulos.precio * det.unidades),0) " + 
			    " from Compras co  join co.detallecomprases det " + 
			    "  where co.clientes.codigoCli = ?");
		 consu.setShort(0,cli.getCodigoCli());
		 Double imp  = (Double) consu.uniqueResult();
		 if (imp >maximp) maximp=imp.floatValue();
		 if (numc >maxcom) maxcom=numc;
		 cadena=String.format(patron, cli.getCodigoCli(), cli.getNombre(), cli.getLocalidad(), numc,imp );
	     System.out.println(cadena);	   
	}
	System.out.println("-------- --------------------- ---------------- ----------- -------------");	   
	// total compras
	Long numco =   (Long) session.createQuery(
		    "select count(*) from Compras").uniqueResult();
	Double suma =  (Double) session.createQuery(
			"select coalesce(sum( det.articulos.precio * det.unidades),0) " + 
		    " from Compras co  join co.detallecomprases det " ).uniqueResult();
	 patron="%-8s %-20s  %-15s %8d \t%7.2f ";
	 cadena = String.format(patron, " ","TOTALES ",  " ", numco,  suma);
	 System.out.println(cadena);	
	 System.out.println("-------- --------------------- ---------------- ----------- -------------");	 
	
	 // número de clientes
	 System.out.printf("Número de clientes:  %-7d \n", lista.size()); 
	 // media de compras por cliente
	 float mediacomp = (float) (numco)/(lista.size());
	 System.out.printf("Media de compras por clientes:  %-7.2f \n", mediacomp); 
	 // media de importe por cliente
	 float mediaimp =  (suma.floatValue())/(lista.size());
	 System.out.printf("Media de importe por clientes:  %-7.2f \n", mediaimp); 
	 // cliente con más compra
	 
	 q = session.createQuery(" select co.clientes.codigoCli, co.clientes.nombre, " +
	    " count(*) from Compras co  " + 
	    " group by co.clientes.codigoCli, co.clientes.nombre " +
	    " having   count(*)  = " + maxcom );
	 List<Object[]> climacommax = q.list(); 
	 System.out.printf("Clientes con máximo de compras (máximo=%.0f): \n",maxcom );
	 for (int i = 0; i < climacommax.size(); i++)
	 {
	   Object res[] = climacommax.get(i); 
	   System.out.printf("\tCod Cliente: %d, Nombre: %s \n", res[0],  res[1]); 
	  }
	 // clientes con mas importe
	 q = session.createQuery("select co.clientes.codigoCli, co.clientes.nombre, "+
	    " sum( det.articulos.precio * det.unidades)  "+
	     " from Compras co  join co.detallecomprases det "+
	     " group by  co.clientes.codigoCli,co.clientes.nombre "+
	     " having  sum( det.articulos.precio * det.unidades) = " + maximp );
	List<Object[]> climaximp = q.list(); 
	System.out.printf("Clientes con importe máximo (máximo=%7.2f): \n",maximp );
	for (int i = 0; i < climaximp.size(); i++)
	{
	  Object res[] = climaximp.get(i); 
	  System.out.printf("\tCod Cliente: %d, Nombre: %s \n", res[0],  res[1]); 
	 }
}
else
	System.out.println(" <<<<<<<<< NO HAY CLIENTES >>>>>>> ");	  
System.out.println("-------- --------------------- ---------------- ----------- -------------");	 
volveralmenu();	

} // resumenclientes
////////////////////////////////////////////////////////////////////////////////////
private static void resumenarticulos () {
int sumastock =0;
long sumuni=0, maxuni = 0, maxnumcompra=0;
float totalimpor=0, maximpor=0;

System.out.println("--------------------------------------------------------------------------------------------------------------");
System.out.println("                           RESUMEN DATOS DE ARTICULOS ");	  
System.out.println("--------------------------------------------------------------------------------------------------------------");
System.out.println("COD ARTI     DENOMINACION            PRECIO   STOCK  SUM UNIDAVEND  TOTALIMPORTE NUM_COMP NOMBRE PROVEEDOR");
System.out.println("-------- -------------------------- -------- ------- -------------- ------------ -------- --------------------");	   
String patron="%-8d %-26s %7.2f %7d \t%7d \t%8.2f %8d %-20s";
String cadena ="";

Articulos arti = new Articulos(); 			
Query q = session.createQuery("select a.codarticulo , a.denominacion , a.precio , a.stock , " +
      " coalesce(sum(det.unidades), 0) , coalesce(a.precio * sum(det.unidades),0) , " + 
	  " count(distinct det.compras.numcompra) , a.proveedores.nombre " +
      " from Articulos a left join a.detallecomprases det " +
      " group by a.codarticulo , a.denominacion, a.stock, a.precio,  a.proveedores.nombre " +
      " order by a.codarticulo");

List<Object[]> artic = q.list(); 
if (artic.size() >0)
{
	for (int i = 0; i < artic.size(); i++)
	{
	   Object res[] = artic.get(i); 
	   cadena = String.format(patron, res[0],  res[1],  res[2],  res[3],  
			      res[4],  res[5],  res[6], res[7]);
	   System.out.println(cadena);	 
	   sumastock = sumastock + (short)res[3] ;
	   sumuni= sumuni + ((long) res[4]) ;
	   totalimpor= totalimpor +  (float) res[5];
	   float imp = (float) res[5];;
	   long numc = (long) res[6];   
	   long uni = (long) res[4];  
	   // guardamos los máximos para luego seleccionar los que tienen ese máximo
	   if (uni > maxuni)  maxuni = uni;
	   if (imp > maximpor)  maximpor = imp;
	   if (numc > maxnumcompra)  maxnumcompra = numc;
	}
	
	System.out.println("-------- -------------------------- -------- ------- -------------- ------------ -------- --------------------");
	patron="%-8s %-26s %7s %7d \t%7d \t%8.2f";
	cadena = String.format(patron, " ","TOTALES ",  " ", sumastock,  sumuni,  totalimpor);
	System.out.println(cadena);	
	float mediauni = sumuni / artic.size();
	float mediaimpor = totalimpor / artic.size();
	System.out.println("-------- -------------------------- -------- ------- -------------- ------------ -------- --------------------");
	System.out.printf("Número de artículos:  %-7d \n", artic.size()); 
	System.out.printf("Media de unidades por artículo:  %-7.2f\n", mediauni); 
	System.out.printf("Media de importe por artículo:  %-7.2f \n", mediaimpor); 
	// Media de stock, creamos una consulta
	Double mediastc =   (Double) session.createQuery(
			  "select avg(a.stock) from Articulos a").uniqueResult();
	System.out.printf("Media de stock :  %7.2f \n",mediastc );
	// Artículo con más unidades vendidas
	q = session.createQuery("select a.codarticulo , a.denominacion "+
		      " from Articulos a  join a.detallecomprases det " +
		      " group by a.codarticulo  " +
		      " having sum(det.unidades)= " + maxuni );
	List<Object[]> armaxunida = q.list(); 	
	System.out.printf("Artículos con más unidades (máximo = %d): \n",maxuni );
	for (int i = 0; i < armaxunida.size(); i++)
	{
	   Object res[] = armaxunida.get(i); 
	   System.out.printf("\tCod articulo: %d, Denominación: %s \n", res[0],  res[1]); 
	  }
	
	// artículo o artículos con más importe
	q = session.createQuery("select a.codarticulo , a.denominacion "+
		      " from Articulos a join a.detallecomprases det " +
		      " group by a.codarticulo, a.precio  " +
		      " having  (a.precio * sum(det.unidades)) = " + maximpor );
	List<Object[]> armaximp = q.list(); 
	System.out.printf("Artículos con más importe (máximo = %.2f): \n",maximpor );
	for (int i = 0; i < armaximp.size(); i++)
	{
	 Object res[] = armaximp.get(i); 
	 System.out.printf("\tCod articulo: %d, Denominación: %s \n", res[0],  res[1]); 
	}
	
	// artículos con más compras
	q = session.createQuery("select a.codarticulo , a.denominacion "+
		      " from Articulos a join a.detallecomprases det " +
		      " group by a.codarticulo, a.precio  " +
		      " having  count(distinct det.compras.numcompra) = " + maxnumcompra );
	List<Object[]> armaxcomp = q.list(); 
	System.out.printf("Artículos con más compras (máximo = %d): \n",maxnumcompra );
	for (int i = 0; i < armaxcomp.size(); i++)
	{
		Object res[] = armaxcomp.get(i); 
		System.out.printf("\tCod articulo: %d, Denominación: %s \n", res[0],  res[1]); 
	}
}
else
	System.out.println(" <<<<<<<<< NO HAY ARTÍCULOS >>>>>>> ");	  
System.out.println("--------------------------------------------------------------------------------------------------------------");

volveralmenu();	

}//resumenarticulos

////////////////////////////////////////////////////////////////////////////////////
private static void dibujamenu() {  	
	System.out.println("\t..............................................................");
	System.out.println("\t. Resúmenes. Consultas más complejas. BD prueba de MySQL ..");
	System.out.println("\t..............................................................\n"
	+ "\t\t.  1 Resumen de artículos. \n"
	+ "\t\t.  2 Resumen de clientes.  \n"
	+ "\t\t.  3 Resumen de proveedores. \n"
	+ "\t\t.  4 Detalle de las compras de los clientes. \n"
	+ "\t\t.  0 SALIR.\n"
	+ "\t.................................................................\n");
} // fin dibujamenu
////////////////////////////////////////////////////////////////////////////////////
private static void volveralmenu() {
try {
	System.out.println( "Pulsa una tecla para volver. ");
	System.in.read();
	} catch (IOException e) {System.out.println (e);}
}// volveralmenu
////////////////////////////////////////////////////////////////////////////////////
}
